/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/callback/CallbackConstants.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc. 
 * All rights reserved.
 */
package com.netapp.common.callback;

import static com.netapp.common.util.ConfigProperty.intProperty;

import com.netapp.common.util.ConfigProperty;


/**
 * Defines constants required by the callback API.
 * 
 * @author joshb
 *
 */
public class CallbackConstants {

    private CallbackConstants() {
    }
    
    /**
     * How long to wait between poll events.
     */
    public static final ConfigProperty<Integer> POLL_INTERVAL = intProperty("callback.poll.interval", 5);

    /**
     * Maximum number of times to retry until there is work to be processed by the polling thread. If the
     * thread sleeps for MAX_SETUP_POLL_RETRIES * POLL_INTERVAL without having any work to process, then
     * the thread will terminate itself.
     */
    public static final ConfigProperty<Integer> MAX_SETUP_POLL_RETRIES = intProperty("callback.poll.setup.maxRetry", 10);
    
    /**
     * Number of times to retry polling the server for information. This allows the server to be temporally
     * unavailable for a short period of time without stopping the entire callback API.
     */
    public static final ConfigProperty<Integer> MAX_POLL_RETRY = intProperty("callback.poll.maxRetry", 10);
}
