/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/cli/binding/GlobalBindings.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.cli.binding;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.cli2.CommandLine;

import com.netapp.common.cli.validator.ValidationException;

public class GlobalBindings implements BindingContainer {

    private List<FieldBinding> fieldBindings;
    
    public GlobalBindings() {
        this.fieldBindings = new ArrayList<FieldBinding>();
    }
    
    public void hydrate(Object object, CommandLine commandLine) throws ValidationException {
        try {
            for (FieldBinding fieldBinding : this.fieldBindings) {
                Object value = fieldBinding.hydrate(commandLine);    
                fieldBinding.fieldSetter.invoke(object, value);
            }
        }
        catch (IllegalAccessException e) {
            throw new RuntimeException(e);
        }
        catch (IllegalArgumentException e) {
            throw new RuntimeException(e);
        }
        catch (InvocationTargetException e) {
            throw new RuntimeException(e);
        }
    }

    public List<FieldBinding> getFieldBindings() {
        return this.fieldBindings;
    }
}
