/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/credentials/PersistentFileCredential.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc. 
 * All rights reserved.
 */
package com.netapp.common.credentials;

/**
 * An internal class representing the YAML format in which we persist the credential information.
 * This class is used by FileCredentialPersistenceManager.
 * 
 * @author joshb
 *
 */
public class PersistentFileCredential {
    private CredentialKey key;
    private String type;
    private String password;

    public PersistentFileCredential() {
    }

    public CredentialKey getKey() {
        return key;
    }

    public void setKey(CredentialKey key) {
        this.key = key;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * Two PersistentFileCredentials are equal if and only if
     * their key and type are equal. For this check, we do not 
     * check if the passwords are equal.
     */
    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof PersistentFileCredential)) {
            return false;
        }

        PersistentFileCredential other = (PersistentFileCredential) obj;

        if (getKey().equals(other.getKey()) && getType().equalsIgnoreCase(other.getType())) {
            return true;
        }

        return false;
    }
    
    public boolean equalsIgnoreCase(PersistentFileCredential other) {
        if (getKey().getKey().length != other.getKey().getKey().length) {
            return false;
        }
        
        for (int i = 0; i < getKey().getKey().length; i++) {
            if (!getKey().getKey()[i].equalsIgnoreCase(other.getKey().getKey()[i])) {
                return false;
            }
        }
        
        if (!getType().equalsIgnoreCase(other.getType())) {
            return false;
        }
        
        return true;
    }

    @Override
    public int hashCode() {
        return getKey().hashCode() + getType().hashCode();
    }
}
