/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/api/OperationStartResult.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow.api;

import java.io.Serializable;

import javax.xml.bind.annotation.XmlType;

/**
 * Structure representing the result of an operation start call.
 * 
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
@XmlType(namespace = "http://www.netapp.com/smai/Operation")
public class OperationStartResult implements Serializable {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    /**
     * The new Id of the operation if the start was successful. Empty if there was
     * an error during operation start.
     */
    protected String id;
    /**
     * The error that occured during operation start, or empty if the operation was
     * queued successfully.
     */
    protected String error;
    
    public OperationStartResult() {
        
    }
    
    public void setId(String operationId) {
        this.id = operationId;
    }
    
    public String getId() {
        return this.id;
    }
    
    public void setError(String error) {
        this.error = error;
    }
    
    public String getError() {
        return this.error;
    }
    
    public boolean hasError() {
        return this.error != null;
    }
}
