/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/tasks/diag/CreateBeanXml.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow.tasks.diag;

import java.beans.XMLEncoder;
import java.io.File;
import java.io.FileOutputStream;

import com.netapp.common.MsgKey;
import com.netapp.common.flow.Task;
import com.netapp.common.flow.TaskInput;
import com.netapp.common.logging.NALogger;

/**
 * Dump an object to an XML representation on disk.
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class CreateBeanXml implements Task {
    private static final NALogger logger = NALogger.getLogger(CreateBeanXml.class);
    private String path;
    private String filename;
    private Object bean;

    /**
     * @see com.netapp.common.flow.Task#execute()
     */
    public void execute() throws Exception {
        assert this.path != null;
        assert this.filename != null;
        assert this.bean != null;
        
        File file = new File(path, filename);
        logger.info(MsgKey.FLOW_TASK_DIAG_CREATE_BEAN_XML, bean.getClass().getName(), file);
        XMLEncoder enc = new XMLEncoder(new FileOutputStream(file));
        enc.writeObject(this.bean);
        enc.close();
    }

    /**
     * Set the bean to dump
     * @param bean
     */
    @TaskInput
    public void setBean(Object bean) {
        this.bean = bean;
    }
    
    /**
     * Set the base path of the file to use
     * @param path
     */
    @TaskInput
    public void setPath(String path) {
        this.path = path;
    }
    
    /**
     * Set the filename to use
     * @param filename
     */
    public void setFilename(String filename) {
        this.filename = filename;
    }
}
