/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/logging/LogLevel.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.logging;

import javax.xml.bind.annotation.XmlType;

/**
 * Our log levels. Used to map back to Log4j hierarchies,
 * and allow us to change out what log package we use in
 * the future.
 */
@XmlType(name = "logLevel", namespace = "http://www.netapp.com/smai/Operation")
public enum LogLevel {
    TRACE,
    DEBUG,
    INFO,
    WARN,
    ERROR,
    FATAL,
    PROGRESS;
    
    /**
     * Map a string level back to an enum. If the string does not match,
     * the default is returned instead of throwing an exception like valueOf.
     * @param name Name of the log level
     * @return Log level corresponding to the supplied name, or a default if name did not match
     */
    public static LogLevel parseLevel(String name) {
        LogLevel result = DEBUG;
        if (name != null) {
            try {
                result = valueOf(LogLevel.class, name.toUpperCase());
            }
            catch (IllegalArgumentException e) { }
        }
        return result;
    }
}
