/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/remote/RemoteObjectFactoryAware.java#1 $
 * 
 * Copyright (c) 2008 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.remote;

/**
 * Remote objects can implement this interface if they wish to 
 * be aware of things related to the RemoteObjectFactory from which
 * they were instantiated.
 * 
 * Currently, the only thing that they are made aware of is the "Destroy Runnable"
 * 
 * @author sirianni
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public interface RemoteObjectFactoryAware {

    /**
     * Set a reference to the "Destroy Runnable".
     * This is a {@link Runnable} that will destroy the RemoteObjectFactory
     * and the JVM when invoked.
     * 
     * @param runnable the "Destroy Runnable"
     */
    void setDestroyRunnable(Runnable runnable);
    
}
