/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/WordReplacementTransformer.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator;

import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

import com.netapp.common.util.Transformer;

public class WordReplacementTransformer implements Transformer<String, String> {
    
    private final Map<String, String> wordsToReplace;
    
    public WordReplacementTransformer() {
        this.wordsToReplace = new HashMap<String, String>();
    }
    
    public void addWordReplacement(String wordToReplace, String newWord) {
        this.wordsToReplace.put(wordToReplace, newWord);
    }
    
    /**
     * Returns a translation of the original string with all of the
     * word replacements defined in wordsToReplace replaced.
     */
    public String transform(String original) {
        if (original == null) {
            return null;
        }
        StringBuilder result = new StringBuilder(original.length());
        String delimiters = " \t\n\r\"\'()<>&;.,:";
        StringTokenizer st = new StringTokenizer(original, delimiters, true);
        while (st.hasMoreTokens()) {
            String word = st.nextToken();
            
            String newWord = this.wordsToReplace.get(word); 
            if (newWord != null) {
                result.append(newWord);
            }
            else {
                result.append(word);
            }
        }
        return result.toString();
    }
    
}
