/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/wsdl/WsdlGeneratorFactory.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator.wsdl;

import com.netapp.common.zapi.generator.GeneratorFactory;
import com.netapp.common.zapi.parser.Category;
import com.netapp.common.zapi.parser.Field;
import com.netapp.common.zapi.parser.Namespace;
import com.netapp.common.zapi.parser.Type;

public class WsdlGeneratorFactory extends GeneratorFactory<WsdlNamespaceGenerator, WsdlCategoryGenerator, WsdlTypeGenerator, WsdlFieldGenerator> {
    
    @Override
    public WsdlNamespaceGenerator getNamespaceGenerator(Namespace namespace) {
        return new WsdlNamespaceGenerator(this, namespace);
    }
    
    @Override
    public WsdlCategoryGenerator getCategoryGenerator(Category category) {
        return new WsdlCategoryGenerator(this, category);
    }
    
    @Override
    public WsdlTypeGenerator getTypeGenerator(Type type) {
        return new WsdlTypeGenerator(this, type);
    }
    
    @Override
    public WsdlFieldGenerator getFieldGenerator(Field field) {
        return new WsdlFieldGenerator(this, field);
    }
    
}
